#include "Global.h"
#include "Definitions.h"
#include "IterateurCoupW.h"  

// itere tous les coups possibles dans l'tat actuel du plateau
void findAllW() { 
	// reinitialisations
	setCoupsW.clear();
	coup.prb=false;
	coup.prn=false;
	coup.grb=false;
	coup.grn=false;
	coup.enPassant=-1;
	coup.roque=false;
	coup.promotion=0;

	// recherche la situation du roi
	checkKingW();

	findAllMovesW();

	lastCheckW=(check || sCheck>=0);

	return;
}

void findAllMovesW() {
	
	if (dec) {
		// tester que les coups de roi
		if (plateau.roiB==0) {
			coup.dep=0;
			if (plateau[1]<=0) {
				coup.arr=1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[8]<=0) {
				coup.arr=8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[9]<=0) {
				coup.arr=9;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (plateau.roiB==7) {
			coup.dep=7;
			if (plateau[6]<=0) {
				coup.arr=6;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[15]<=0) {
				coup.arr=15;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[14]<=0) {
				coup.arr=14;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (plateau.roiB<8) {
			coup.dep=plateau.roiB;
			if (plateau[plateau.roiB-1]<=0) {
				coup.arr=plateau.roiB-1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+1]<=0) {
				coup.arr=plateau.roiB+1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+7]<=0) {
				coup.arr=plateau.roiB+7;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+8]<=0) {
				coup.arr=plateau.roiB+8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+9]<=0) {
				coup.arr=plateau.roiB+9;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (plateau.roiB==56) {
			coup.dep=56;
			if (plateau[57]<=0) {
				coup.arr=57;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[48]<=0) {
				coup.arr=48;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[49]<=0) {
				coup.arr=49;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (plateau.roiB==63) {
			coup.dep=63;
			if (plateau[62]<=0) {
				coup.arr=62;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[55]<=0) {
				coup.arr=55;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[54]<=0) {
				coup.arr=54;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (plateau.roiB>56) {
			coup.dep=plateau.roiB;
			if (plateau[plateau.roiB-1]<=0) {
				coup.arr=plateau.roiB-1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+1]<=0) {
				coup.arr=plateau.roiB+1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-7]<=0) {
				coup.arr=plateau.roiB-7;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-8]<=0) {
				coup.arr=plateau.roiB-8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-9]<=0) {
				coup.arr=plateau.roiB-9;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (mod8[plateau.roiB]<=0) {
			coup.dep=plateau.roiB;
			if (plateau[plateau.roiB+1]<=0) {
				coup.arr=plateau.roiB+1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+9]<=0) {
				coup.arr=plateau.roiB+9;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+8]<=0) {
				coup.arr=plateau.roiB+8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-8]<=0) {
				coup.arr=plateau.roiB-8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-7]<=0) {
				coup.arr=plateau.roiB-7;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		if (mod8[plateau.roiB]>=7) {
			coup.dep=plateau.roiB;
			if (plateau[plateau.roiB-1]<=0) {
				coup.arr=plateau.roiB-1;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+7]<=0) {
				coup.arr=plateau.roiB+7;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB+8]<=0) {
				coup.arr=plateau.roiB+8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-8]<=0) {
				coup.arr=plateau.roiB-8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (plateau[plateau.roiB-9]<=0) {
				coup.arr=plateau.roiB-9;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			return;
		}
		// centre
		coup.dep=plateau.roiB;
		if (plateau[plateau.roiB+1]<=0) {
			coup.arr=plateau.roiB+1;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB-1]<=0) {
			coup.arr=plateau.roiB-1;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB+8]<=0) {
			coup.arr=plateau.roiB+8;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB-8]<=0) {
			coup.arr=plateau.roiB-8;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB+9]<=0) {
			coup.arr=plateau.roiB+9;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB-9]<=0) {
			coup.arr=plateau.roiB-9;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB+7]<=0) {
			coup.arr=plateau.roiB+7;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau[plateau.roiB-7]<=0) {
			coup.arr=plateau.roiB-7;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		return;
	}
	if (check || sCheck>0) {
		if (check) attackSq=lastMove.arr;
		else attackSq=sCheck;
		int type=plateau[attackSq];
		// parcours des coups: un coup legal prendra l'agresseur, bougera le roi ou s'interposera
		switch (type) {
		
		/********************************
		* la piece attaquante est un pion
		*********************************/
		
		case -1 :
			attackPionW();
			break;
			
		/************************************
		* la piece attaquante est un cavalier
		************************************/
			
		case -2 :
			attackCavalierW();
			break;

		/*******************************
		* la piece attaquante est un fou
		********************************/
			
		case -3 :
			attackFouW();
			break;

		/*********************************
		* la piece attaquante est une tour
		**********************************/
			
		case -4 :
			attackTourW();
			break;

		/*********************************
		* la piece attaquante est une dame
		**********************************/
			
		default :
			attackDameW();
		}				
	}
	else {
		// parcours des coups 
		for (int i=63; i>=0; i--) 
			if (plateau[i]>0) findMovesW(i);
	}
	
	return;
}

// itere tous les coups possibles pour une piece donnee et les ajoute dans l'ensemble de coups (roi non en echec)
void findMovesW(int piece) {   

	coup=Coup(piece,piece); 

	if (plateau[piece]==1) { // pion blanc
		// on commence par verifier si on peut avancer (eventuellement de deux cases)
		if (piece<16 && plateau[piece+8]==0 && plateau[piece+16]==0) {
			coup.arr=piece+16;
			if (!underCheckW(coup)) setCoupsW.push_back(coup); 
		}
		if (plateau[piece+8]==0) { 
			// deux cas: promotion ou non
			if (piece>=48) {
				coup.arr=piece+8; 
				if (!underCheckW(coup)) {
					for (int i=2; i<6; i++) {
						coup.promotion=i;
						setCoupsW.push_back(coup); 
					}
				}
			}
			else {
				coup.arr=piece+8;
				if (!underCheckW(coup)) setCoupsW.push_back(coup); 
			}  
		}
		if (mod8[piece]==0) { // on est sur le bord gauche
			if (plateau[piece+9]<0) {
				// ajout de chaque promotion si necessaire
				if (piece>=48) {
					coup.arr=piece+9; 
					if (!underCheckW(coup)) {
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup); 
						}
					}
				}
				else {
					coup.arr=piece+9;
					if (!underCheckW(coup)) setCoupsW.push_back(coup);
				}
			}
			// une prise et une prise en passant sont mutuellement exclusives
			else if (plateau[lastMove.arr]==-1 && piece+1==lastMove.arr && lastMove.dep-lastMove.arr>=16) {    
				coup.arr=piece+9;
				coup.enPassant=lastMove.arr;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);   
			}
		}   
		else if (mod8[piece]==7) { // on est sur le bord droit 
			if (plateau[piece+7]<0) {
				// ajout de chaque promotion si necessaire
				if (piece>=48) {
					coup.arr=piece+7; 
					if (!underCheckW(coup)) {
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup); 
						}
					}
				}
				else {
					coup.arr=piece+7;
					if (!underCheckW(coup)) setCoupsW.push_back(coup);
				}
			}
			// une prise et une prise en passant sont mutuellement exclusives
			else if (plateau[lastMove.arr]==-1 && piece-1==lastMove.arr && lastMove.dep-lastMove.arr>=16) {   
				coup.arr=piece+7;
				coup.enPassant=lastMove.arr;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}    
		else { // on est au milieu du plateau 
			bool checkEP=true;
			if (plateau[piece+9]<0) {
				checkEP=false;                      
				// ajout de chaque promotion si necessaire
				if (piece>=48) {
					coup.arr=piece+9;
					if (!underCheckW(coup)) { 
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup); 
						}
					}
				}
				else {
					coup.arr=piece+9;
					if (!underCheckW(coup)) setCoupsW.push_back(coup);
				}
			}
			// une prise et une prise en passant sont mutuellement exclusives
			if (checkEP && plateau[lastMove.arr]==-1 && piece+1==lastMove.arr && lastMove.dep-lastMove.arr>=16) {   
				coup.arr=piece+9;
				coup.enPassant=lastMove.arr;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);  
			}
			checkEP=true;
			coup.enPassant=-1;
			if (plateau[piece+7]<0) {
				checkEP=false;                      
				// ajout de chaque promotion si necessaire
				if (piece>=48) {
					coup.arr=piece+7;
					if (!underCheckW(coup)) {
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup); 
						}
					}
				}
				else {
					coup.arr=piece+7;
					if (!underCheckW(coup)) setCoupsW.push_back(coup);
				}
			}
			// une prise et une prise en passant sont mutuellement exclusives
			if (checkEP && plateau[lastMove.arr]==-1 && piece-1==lastMove.arr && lastMove.dep-lastMove.arr>=16) {   
				coup.arr=piece+7;
				coup.enPassant=lastMove.arr;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}
		return;
	}
 
	if (plateau[piece]==2) { // cavalier blanc
		// exploration a droite
		if (mod8[piece]<6) {
			if (piece+10<64 && plateau[piece+10]<=0) {
				coup.arr=piece+10;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}	
			if (piece-6>=0 && plateau[piece-6]<=0) {	
				coup.arr=piece-6;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}
		// exploration a gauche
		if (mod8[piece]>1) {
			if (piece+6<64 && plateau[piece+6]<=0) {
				coup.arr=piece+6;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
			if (piece-10>=0 && plateau[piece-10]<=0) {
				coup.arr=piece-10;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}
		// exploration en haut
		if (piece<48) {
			if (mod8[piece]!=7 && plateau[piece+17]<=0) {
				coup.arr=piece+17;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
			if (mod8[piece]!=0 && plateau[piece+15]<=0) {
				coup.arr=piece+15;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}
		// exploration en bas
		if (piece>=16) {
			if (mod8[piece]!=7 && plateau[piece-15]<=0) {
				coup.arr=piece-15;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
			if (mod8[piece]!=0 && plateau[piece-17]<=0) {
				coup.arr=piece-17;
				if (!underCheckW(coup)) setCoupsW.push_back(coup);
			}
		}
		return;
	} 
      
	if (plateau[piece]==3) { // fou blanc
		int posCour=piece; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
		// exploration diagonale h-droite
		while (mod8[posCour]!=7 && posCour<55) {
			if (plateau[posCour+9]>0) break;
			coup.arr=posCour+9;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour+=9;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale h-gauche
		posCour=piece;
		while (mod8[posCour]!=0 && posCour<56) {
			if (plateau[posCour+7]>0) break;
			coup.arr=posCour+7;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour+=7;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale b-droite
		posCour=piece;
		while (mod8[posCour]!=7 && posCour>=8) {
			if (plateau[posCour-7]>0) break;
			coup.arr=posCour-7;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour-=7;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale b-gauche
		posCour=piece;
		while (mod8[posCour]!=0 && posCour>=9) {
			if (plateau[posCour-9]>0) break;
			coup.arr=posCour-9;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour-=9;
			if (plateau[posCour]<0) break;
		}
		return;
	}
      
	if (plateau[piece]==4) { // tour blanche
		int posCour=piece; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
		// exploration verticale haute
		while (posCour<56) { 
			if (plateau[posCour+8]>0) break;
			coup.arr=posCour+8;
			if (!underCheckW(coup)) {
				if (piece==0) coup.grb=false;
				else if (piece==7) coup.prb=false;
				setCoupsW.push_back(coup);
			} 
			posCour+=8;
			if (plateau[posCour]<0) break;
		}
		// exploration verticale basse
		posCour=piece;
		while (posCour>=8) { 
			if (plateau[posCour-8]>0) break;
			coup.arr=posCour-8;
			if (!underCheckW(coup)) {
				if (piece==0) coup.grb=false;
				else if (piece==7) coup.prb=false;
				setCoupsW.push_back(coup);
			}  
			posCour-=8;
			if (plateau[posCour]<0) break;
		}
		// exploration horizontale droite
		posCour=piece;
		while (mod8[posCour]!=7) { 
			if (plateau[posCour+1]>0) break;
			coup.arr=++posCour;
			if (!underCheckW(coup)) {
				if (piece==0) coup.grb=false;
				else if (piece==7) coup.prb=false;
				setCoupsW.push_back(coup);
			}
			if (plateau[posCour]<0) break;
		}
		// exploration horizontale gauche
		posCour=piece;
		while (mod8[posCour]!=0) { 
			if (plateau[posCour-1]>0) break;
			coup.arr=--posCour;
			if (!underCheckW(coup)) {
				if (piece==0) coup.grb=false;
				else if (piece==7) coup.prb=false;
				setCoupsW.push_back(coup);
			}
			if (plateau[posCour]<0) break;
		}
		return;
	}     
	  
	if (plateau[piece]==5) { // dame blanche
		int posCour=piece; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
		// exploration diagonale h-droite
		while (mod8[posCour]!=7 && posCour<55) {
			if (plateau[posCour+9]>0) break;
			coup.arr=posCour+9;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour+=9;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale h-gauche
		posCour=piece;
		while (mod8[posCour]!=0 && posCour<56) {
			if (plateau[posCour+7]>0) break;
			coup.arr=posCour+7;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour+=7;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale b-droite
		posCour=piece;
		while (mod8[posCour]!=7 && posCour>=8) {
			if (plateau[posCour-7]>0) break;
			coup.arr=posCour-7;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour-=7;
			if (plateau[posCour]<0) break;
		}
		// exploration diagonale b-gauche
		posCour=piece;
		while (mod8[posCour]!=0 && posCour>=9) {
			if (plateau[posCour-9]>0) break;
			coup.arr=posCour-9; 
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour-=9;
			if (plateau[posCour]<0) break;
		}
		// exploration verticale haute
		posCour=piece;		
		while (posCour<56) { 
			if (plateau[posCour+8]>0) break;
			coup.arr=posCour+8; 
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour+=8;
			if (plateau[posCour]<0) break;
		}
		// exploration verticale basse
		posCour=piece;
		while (posCour>=8) { 
			if (plateau[posCour-8]>0) break;
			coup.arr=posCour-8; 
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			posCour-=8;
			if (plateau[posCour]<0) break;
		}
		// exploration horizontale droite
		posCour=piece;
		while (mod8[posCour]!=7) { 
			if (plateau[posCour+1]>0) break;
			coup.arr=++posCour;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			if (plateau[posCour]<0) break;
		}
		// exploration horizontale gauche
		posCour=piece;
		while (mod8[posCour]!=0) { 
			if (plateau[posCour-1]>0) break;
			coup.arr=--posCour;
			if (!underCheckW(coup)) setCoupsW.push_back(coup);
			if (plateau[posCour]<0) break;
		}
		return;
	} 
      
	if (plateau[piece]==6) { // roi blanc
		// bord gauche
		if (mod8[piece]==0) { 
			if (piece>=8) {
				if (plateau[piece-7]<=0) {
					coup.arr=piece-7;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece-8]<=0) {
					coup.arr=piece-8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
			}
			if (plateau[piece+1]<=0) {
				coup.arr=piece+1;
				if (!underCheckW_K(coup)) {
					coup.prb=false;
					coup.grb=false;
					setCoupsW.push_back(coup);
				}
			}  
			if (piece<55) {
				if (plateau[piece+9]<=0) {
					coup.arr=piece+9;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece+8]<=0) {
					coup.arr=piece+8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}
			}   
		}
		else if (mod8[piece]==7) { // bord droit
			if (piece>=9) {
				if (plateau[piece-9]<=0) {
					coup.arr=piece-9;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece-8]<=0) {
					coup.arr=piece-8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
			}
			if (plateau[piece-1]<=0) {
				coup.arr=piece-1;
				if (!underCheckW_K(coup)) {
					coup.prb=false;
					coup.grb=false;
					setCoupsW.push_back(coup);
				}
			}  
			if (piece<56) {
				if (plateau[piece+7]<=0) {
					coup.arr=piece+7;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece+8]<=0) {
					coup.arr=piece+8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}
			} 
		}
		else { // milieu du plateau
			// deplacements lateraux toujours possibles
			if (plateau[piece-1]<=0) { 
				coup.arr=piece-1; 
				if (!underCheckW_K(coup)) {
					coup.prb=false;
					coup.grb=false;
					setCoupsW.push_back(coup);
				}
			}  
			if (plateau[piece+1]<=0) {
				coup.arr=piece+1;
				if (!underCheckW_K(coup)) {
					coup.prb=false;
					coup.grb=false;
					setCoupsW.push_back(coup);
				}
			} 
			if (piece>=8) {
				if (plateau[piece-7]<=0) {
					coup.arr=piece-7;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece-8]<=0) {
					coup.arr=piece-8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece-9]<=0) {
					coup.arr=piece-9;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}   
			} 
			if (piece<55) {
				if (plateau[piece+9]<=0) {
					coup.arr=piece+9;
					if (!underCheckW_K(coup)) { 
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}  
				if (plateau[piece+8]<=0) {
					coup.arr=piece+8;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				}
				if (plateau[piece+7]<=0) {
					coup.arr=piece+7;
					if (!underCheckW_K(coup)) {
						coup.prb=false;
						coup.grb=false;
						setCoupsW.push_back(coup);
					}
				} 
			}
			if (piece==4) {
				if (lastMove.prb && plateau[5]==0 && plateau[6]==0 && plateau[7]==4) {
					if (!underCheck_4() && !underCheck_5() && !underCheck_6()) {
						coup.arr=6;
						coup.roque=true;
						setCoupsW.push_back(coup);  
					}
				}
				if (lastMove.grb && plateau[3]==0 && plateau[2]==0 && plateau[1]==0 && plateau[0]==4) {
					if (!underCheck_4() && !underCheck_3() && !underCheck_2()) {
						coup.arr=2;
						coup.roque=true;
						setCoupsW.push_back(coup);  
					}  
				}
			} 
		}
		return;
	}
}     
