#include "Global.h"
#include "Definitions.h"
#include "PionW.h"

/* on joue avec les blancs, et on est en echec par un pion noir */

void attackPionW() {

	// coups de roi et prise du pion seulement

	bool ok;
	// d'abord check si roi peut prendre ou se deplacer
	coup.dep=plateau.roiB;
	coup.prb=false;
	coup.grb=false;
	if (mod8[plateau.roiB]>0) {
		if (plateau[plateau.roiB-1]<=0) {
			coup.arr=plateau.roiB-1;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau.roiB>8 && plateau[plateau.roiB-9]<=0) {
			coup.arr=plateau.roiB-9;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau.roiB<=56 && plateau[plateau.roiB+7]<=0) {
			coup.arr=plateau.roiB+7;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
	}
	if (mod8[plateau.roiB]<7) {
		if (plateau[plateau.roiB+1]<=0) {
			coup.arr=plateau.roiB+1;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau.roiB>=8 && plateau[plateau.roiB-7]<=0) {
			coup.arr=plateau.roiB-7;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
		if (plateau.roiB<56 && plateau[plateau.roiB+9]<=0) {
			coup.arr=plateau.roiB+9;
			if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
		}
	}
	if (plateau.roiB>=8 && plateau[plateau.roiB-8]<=0) {
		coup.arr=plateau.roiB-8;
		if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
	}
	if (plateau[plateau.roiB+8]<=0) {
		coup.arr=plateau.roiB+8;
		if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
	}

	coup.arr=attackSq;

	// prise avec un pion (eventuellement en passant, + promotions)
	if (attackSq>=16) {
		if (mod8[attackSq]>0) {
			if (plateau[attackSq-9]==1) {
				ok=true;
				coup.dep=attackSq-9;
				plateau.board[coup.dep]=0;
				// check si decouvertes
				for (int i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=1;
				if (ok) {
					if (attackSq>=56) {
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup);
						}
						coup.promotion=0;
					}
					else setCoupsW.push_back(coup);
				}
			}
			if (plateau[attackSq-1]==1 && lastMove.dep-attackSq==16) {
				ok=true;
				coup.dep=attackSq-1;
				coup.arr=attackSq+8;
				if (plateau.roiB+9==attackSq) {
					plateau.board[coup.dep]=0;
					// check si decouvertes
					for (int i=plateau.roiB+8; i<64; i+=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-4 || plateau[i]==-5) ok=false;
							break;
						}
					}
					plateau.board[coup.dep]=1;
					if (ok) setCoupsW.push_back(coup);
				}
				else setCoupsW.push_back(coup);
			}
		}
		if (mod8[attackSq]<7) {
			if (plateau[attackSq-7]==1) {
				ok=true;
				coup.dep=attackSq-7;
				plateau.board[coup.dep]=0;
				// check si decouvertes
				for (int i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=1;
				if (ok) {
					if (attackSq>=56) {
						for (int i=2; i<6; i++) {
							coup.promotion=i;
							setCoupsW.push_back(coup);
						}
						coup.promotion=0;
					}
					else setCoupsW.push_back(coup);
				}
			}
			if (plateau[attackSq+1]==1 && lastMove.dep-attackSq==16) {
				ok=true;
				coup.dep=attackSq+1;
				coup.arr=attackSq+8;
				if (plateau.roiB+7==attackSq) {
					plateau.board[coup.dep]=0;
					// check si decouvertes
					for (int i=plateau.roiB+8; i<64; i+=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-4 || plateau[i]==-5) ok=false;
							break;
						}
					}
					plateau.board[coup.dep]=1;
					if (ok) setCoupsW.push_back(coup);
				}
				else setCoupsW.push_back(coup);
			}
		}
		coup.arr=attackSq;
	}

	// prise avec un cavalier: parfois pas besoin de checker les decouvertes
	if (mod8[attackSq]<6) {
		if (plateau[attackSq+10]==2) {
			coup.dep=attackSq+10;
			setCoupsW.push_back(coup);
		}
		if (plateau[attackSq-6]==2) {
			ok=true;
			coup.dep=attackSq-6;
			plateau.board[coup.dep]=0;
			for (int i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
				if (plateau[i]>0) break;
				if (plateau[i]<0) {
					if (plateau[i]==-4 || plateau[i]==-5) ok=false;
					break;
				}
			}
			plateau.board[coup.dep]=2;
			if (ok) setCoupsW.push_back(coup);
		}
	}
	if (mod8[attackSq]<7) {
		if (attackSq+17<64 && plateau[attackSq+17]==2) {
			coup.dep=attackSq+17;
			if (attackSq-plateau.roiB==7) {
				ok=true;
				plateau.board[coup.dep]=0;
				for (int i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=2;
				if (ok) setCoupsW.push_back(coup);
			}
			else setCoupsW.push_back(coup);
		}
		if (attackSq-15>=0 && plateau[attackSq-15]==2) {
			coup.dep=attackSq-15;
			if (attackSq-plateau.roiB==7) {
				ok=true;
				plateau.board[coup.dep]=0;
				for (int i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=2;
				if (ok) setCoupsW.push_back(coup);
			}
			else setCoupsW.push_back(coup);
		}
	}
	if (mod8[attackSq]>0) {
		if (attackSq+15<64 && plateau[attackSq+15]==2) {
			coup.dep=attackSq+15;
			if (attackSq-plateau.roiB==9) {
				ok=true;
				plateau.board[coup.dep]=0;
				for (int i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=2;
				if (ok) setCoupsW.push_back(coup);
			}
			else setCoupsW.push_back(coup);
		}
		if (attackSq-17>=0 && plateau[attackSq-17]==2) {
			coup.dep=attackSq-17;
			if (attackSq-plateau.roiB==9) {
				ok=true;
				plateau.board[coup.dep]=0;
				for (int i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) ok=false;
						break;
					}
				}
				plateau.board[coup.dep]=2;
				if (ok) setCoupsW.push_back(coup);
			}
			else setCoupsW.push_back(coup);
		}
	}
	if (mod8[attackSq]>1) {
		if (plateau[attackSq+6]==2) {
			coup.dep=attackSq+6;
			setCoupsW.push_back(coup);
		}
		if (plateau[attackSq-10]==2) {
			ok=true;
			coup.dep=attackSq-10;
			plateau.board[coup.dep]=0;
			for (int i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
				if (plateau[i]>0) break;
				if (plateau[i]<0) {
					if (plateau[i]==-4 || plateau[i]==-5) ok=false;
					break;
				}
			}
			plateau.board[coup.dep]=2;
			if (ok) setCoupsW.push_back(coup);
		}
	}

	// prise avec un fou ou une dame en diagonale
	if (attackSq-plateau.roiB==7) {
		for (int i=attackSq+9; i<64 && mod8[i]>0; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=3;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else if (plateau[i]==5) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=5;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
		for (int i=attackSq-9; i>=0 && mod8[i]<7; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=3;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else if (plateau[i]==5) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=5;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
		for (int i=attackSq+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					coup.dep=i;
					setCoupsW.push_back(coup);
				}
				break;
			}
		}
	}
	else {
		for (int i=attackSq+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=3;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else if (plateau[i]==5) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=5;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
		for (int i=attackSq-7; i>=0 && mod8[i]>0; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=3;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else if (plateau[i]==5) {
					if (mod8[i]==mod8[plateau.roiB]) {
						ok=true;
						plateau.board[i]=0;
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						plateau.board[i]=5;
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						}
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
		for (int i=attackSq+9; i<64 && mod8[i]>0; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					coup.dep=i;
					setCoupsW.push_back(coup);
				}
				break;
			}
		}
	}
	
	// prise avec tour ou dame vertical/horizontal
	for (int i=attackSq+8; i<64; i+=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				coup.dep=i;
				setCoupsW.push_back(coup);
			}
			break;
		}
	}
	for (int i=attackSq+1; i<attackSq+8-mod8[attackSq]; i++) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				if (mod8[i]==mod8[plateau.roiB]) {
					ok=true;
					for (int j=i+8; j<64; j+=8) {
						if (plateau[j]>0) break;
						if (plateau[j]<0) {
							if (plateau[j]==-4 || plateau[j]==-5) ok=false;
							break;
						}
					}
					if (ok) {
						coup.dep=i;
						setCoupsW.push_back(coup);
					} 
				}
				else if (plateau.roiB+9==i) {
					ok=true;
					for (int j=i+9; j<64 && mod8[j]>0; j+=9) {
						if (plateau[j]>0) break;
						if (plateau[j]<0) {
							if (plateau[j]==-3 || plateau[j]==-5) ok=false;
							break;
						}
					}
					if (ok) {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else {
					coup.dep=i;
					setCoupsW.push_back(coup);
				}
			}
			break;
		}
	}
	for (int i=attackSq-1; i>=attackSq-mod8[attackSq]; i--) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				if (mod8[i]==mod8[plateau.roiB]) {
					ok=true;
					for (int j=i+8; j<64; j+=8) {
						if (plateau[j]>0) break;
						if (plateau[j]<0) {
							if (plateau[j]==-4 || plateau[j]==-5) ok=false;
							break;
						}
					}
					if (ok) {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else if (plateau.roiB+7==i) {
					ok=true;
					for (int j=i+7; j<64 && mod8[j]<7; j+=7) {
						if (plateau[j]>0) break;
						if (plateau[j]<0) {
							if (plateau[j]==-3 || plateau[j]==-5) ok=false;
							break;
						}
					}
					if (ok) {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				else {
					coup.dep=i;
					setCoupsW.push_back(coup);
				}
			}
			break;
		}
	}
	if (attackSq-plateau.roiB==9) {
		for (int i=attackSq-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					if (div8[i]==div8[plateau.roiB]) {
						ok=true;
						for (int j=i+1; j<i+8-mod8[i]; j++) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						} 
					}
					else if (i+7==plateau.roiB) {
						ok=true;
						for (int j=i-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						} 
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
	}
	else {
		for (int i=attackSq-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					if (div8[i]==div8[plateau.roiB]) {
						ok=true;
						for (int j=i-1; j>=i-mod8[i]; j--) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						} 
					}
					else if (i+9==plateau.roiB) {
						ok=true;
						for (int j=i-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
						if (ok) {
							coup.dep=i;
							setCoupsW.push_back(coup);
						} 
					}
					else {
						coup.dep=i;
						setCoupsW.push_back(coup);
					}
				}
				break;
			}
		}
	}

	return;
}

