#include "Global.h"
#include "Definitions.h"
#include "TourW.h"

/* on joue avec les blancs, et on est en echec par une tour noire */

void attackTourW() {

	bool ok,b1,b2,b3;
	VectorInt cases; // deplacements possibles
	
	for (int i=63; i>=0; i--) {

		if (plateau[i]<=0) continue;

		if (plateau[i]==1) {
			coup.dep=i;
			b1=(attackSq-i==7 && mod8[attackSq]<7) || (attackSq-i==9 && mod8[attackSq]>0);
			b2=(plateau[i+8]==0 && (div8[attackSq]==div8[plateau.roiB] && div8[i]==div8[plateau.roiB]-1 && ((mod8[i]>mod8[plateau.roiB] && mod8[i]<mod8[attackSq]) || (mod8[i]<mod8[plateau.roiB] && mod8[i]>mod8[attackSq]))));
			if (!b2) b3=(div8[i]==1 && plateau[i+8]==0 && plateau[i+16]==0 &&
				(div8[attackSq]==div8[plateau.roiB] && div8[i]==div8[plateau.roiB]-2 && ((mod8[i]>mod8[plateau.roiB] && mod8[i]<mod8[attackSq]) || (mod8[i]<mod8[plateau.roiB] && mod8[i]>mod8[attackSq]))));
			else b3=false;
			if (b1 || b2 || b3) {
				ok=true;
				plateau.board[i]=0;
				// check si decouvertes
				if (div8[i]==div8[plateau.roiB]) {
					if (i<plateau.roiB) {
					for (int j=plateau.roiB-1; j>=plateau.roiB-mod8[plateau.roiB]; j--) {
						if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB+1; j<plateau.roiB+8-mod8[plateau.roiB]; j++) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]==mod8[plateau.roiB]) {
					if (i<plateau.roiB) {
						for (int j=plateau.roiB-8; j>=0; j-=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[plateau.roiB]-mod8[i]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+9; j<64 && mod8[j]>0; j+=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+7; j<64 && mod8[j]<7; j+=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				if (ok) {
					if (b2) {
						coup.arr=i+8;
						setCoupsW.push_back(coup);
					}
					else if (b3) {
						coup.arr=i+16;
						setCoupsW.push_back(coup);
					}
					if (b1) {
						coup.arr=attackSq;
						if (attackSq>=56) {
							for (int i=2; i<6; i++) {
								coup.promotion=i;
								setCoupsW.push_back(coup);
							}
							coup.promotion=0;
						}
						else setCoupsW.push_back(coup);
					}
				}
				plateau.board[i]=1;
			}
		}

		else if (plateau[i]==2) {
			coup.dep=i;
			cases.clear();
			if (div8[attackSq]==div8[plateau.roiB]) {
				if (div8[i]==div8[plateau.roiB]-1) {
					if ((mod8[i]>=mod8[plateau.roiB]-1 && mod8[i]<=mod8[attackSq]-2) || (mod8[i]<=mod8[plateau.roiB]-3 && mod8[i]>=mod8[attackSq]-2))
						cases.push_back(i+10);
					if ((mod8[i]>=mod8[plateau.roiB]+3 && mod8[i]<=mod8[attackSq]+2) || (mod8[i]<=mod8[plateau.roiB]+1 && mod8[i]>=mod8[attackSq]+2))
						cases.push_back(i+6);
				}
				else if (div8[i]==div8[plateau.roiB]+1) {
					if ((mod8[i]>=mod8[plateau.roiB]-1 && mod8[i]<=mod8[attackSq]-2) || (mod8[i]<=mod8[plateau.roiB]-3 && mod8[i]>=mod8[attackSq]-2))
						cases.push_back(i-6);
					if ((mod8[i]>=mod8[plateau.roiB]+3 && mod8[i]<=mod8[attackSq]+2) || (mod8[i]<=mod8[plateau.roiB]+1 && mod8[i]>=mod8[attackSq]+2))
						cases.push_back(i-10);
				}
				else if (div8[i]==div8[plateau.roiB]-2) {
					if ((mod8[i]>=mod8[plateau.roiB] && mod8[i]<=mod8[attackSq]-1) || (mod8[i]<=mod8[plateau.roiB]-2 && mod8[i]>=mod8[attackSq]-1))
						cases.push_back(i+17);
					if ((mod8[i]>=mod8[plateau.roiB]+2 && mod8[i]<=mod8[attackSq]+1) || (mod8[i]<=mod8[plateau.roiB] && mod8[i]>=mod8[attackSq]+1))
						cases.push_back(i+15);
				}
				else if (div8[i]==div8[plateau.roiB]+2) {
					if ((mod8[i]>=mod8[plateau.roiB] && mod8[i]<=mod8[attackSq]-1) || (mod8[i]<=mod8[plateau.roiB]-2 && mod8[i]>=mod8[attackSq]-1))
						cases.push_back(i-15);
					if ((mod8[i]>=mod8[plateau.roiB]+2 && mod8[i]<=mod8[attackSq]+1) || (mod8[i]<=mod8[plateau.roiB] && mod8[i]>=mod8[attackSq]+1))
						cases.push_back(i-17);
				}
			}
			else if (mod8[attackSq]==mod8[plateau.roiB]) {
				if (mod8[i]==mod8[plateau.roiB]-1) {
					if ((div8[i]>=div8[plateau.roiB]-1 && div8[i]<=div8[attackSq]-2) || (div8[i]<=div8[plateau.roiB]-3 && div8[i]>=div8[attackSq]-2))
						cases.push_back(i+17);
					if ((div8[i]>=div8[plateau.roiB]+3 && div8[i]<=div8[attackSq]+2) || (div8[i]<=div8[plateau.roiB]+1 && div8[i]>=div8[attackSq]+2))
						cases.push_back(i-15);
				}
				else if (mod8[i]==mod8[plateau.roiB]+1) {
					if ((div8[i]>=div8[plateau.roiB]-1 && div8[i]<=div8[attackSq]-2) || (div8[i]<=div8[plateau.roiB]-3 && div8[i]>=div8[attackSq]-2))
						cases.push_back(i+15);
					if ((div8[i]>=div8[plateau.roiB]+3 && div8[i]<=div8[attackSq]+2) || (div8[i]<=div8[plateau.roiB]+1 && div8[i]>=div8[attackSq]+2))
						cases.push_back(i-17);
				}
				else if (mod8[i]==mod8[plateau.roiB]-2) {
					if ((div8[i]>=div8[plateau.roiB] && div8[i]<=div8[attackSq]-1) || (div8[i]<=div8[plateau.roiB]-2 && div8[i]>=div8[attackSq]-1))
						cases.push_back(i+10);
					if ((div8[i]>=div8[plateau.roiB]+2 && div8[i]<=div8[attackSq]+1) || (div8[i]<=div8[plateau.roiB] && div8[i]>=div8[attackSq]+1))
						cases.push_back(i-6);
				}
				else if (mod8[i]==mod8[plateau.roiB]+2) {
					if ((div8[i]>=div8[plateau.roiB] && div8[i]<=div8[attackSq]-1) || (div8[i]<=div8[plateau.roiB]-2 && div8[i]>=div8[attackSq]-1))
						cases.push_back(i+6);
					if ((div8[i]>=div8[plateau.roiB]+2 && div8[i]<=div8[attackSq]+1) || (div8[i]<=div8[plateau.roiB] && div8[i]>=div8[attackSq]+1))
						cases.push_back(i-10);
				}
			}
			if (!cases.empty()) {
				ok=true;
				plateau.board[i]=0;
				// check si decouvertes
				if (div8[i]==div8[plateau.roiB]) {
					if (i<plateau.roiB) {
						for (int j=plateau.roiB-1; j>=plateau.roiB-mod8[plateau.roiB]; j--) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB+1; j<plateau.roiB+8-mod8[plateau.roiB]; j++) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]==mod8[plateau.roiB]) {
					if (i<plateau.roiB) {
						for (int j=plateau.roiB-8; j>=0; j-=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[plateau.roiB]-mod8[i]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+9; j<64 && mod8[j]>0; j+=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+7; j<64 && mod8[j]<7; j+=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				plateau.board[i]=2;
				if (ok) {
					for (int j=(int)cases.size()-1; j>=0; j--) {
						coup.arr=cases[j];
						setCoupsW.push_back(coup);
					}
				}
			}
		}

		else if (plateau[i]==3) {
			coup.dep=i;
			cases.clear();
			if (div8[attackSq]==div8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (div8[i]<div8[plateau.roiB]) {
						int j;
						for (j=i+9; mod8[j]>0 && j<plateau.roiB; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; mod8[j]<7 && j<plateau.roiB; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
					}
					else if (div8[i]>div8[plateau.roiB]) {
						int j;
						for (j=i-9; mod8[j]<7 && j>attackSq; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; mod8[j]>0 && j>attackSq; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
					}
				}
				else {
					if (div8[i]<div8[attackSq]) {
						int j;
						for (j=i+9; mod8[j]>0 && j<attackSq; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; mod8[j]<7 && j<attackSq; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
					}
					else if (div8[i]>div8[attackSq]) {
						int j;
						for (j=i-9; mod8[j]<7 && j>plateau.roiB; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; mod8[j]>0 && j>plateau.roiB; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
					}
				}
			}
			else if (mod8[attackSq]==mod8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (mod8[i]<mod8[plateau.roiB]) {
						int j;
						for (j=i+9; j<64 && mod8[j]<mod8[attackSq]; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; j>=0 && mod8[j]<mod8[attackSq]; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
					}
					else if (mod8[i]>mod8[plateau.roiB]) {
						int j;
						for (j=i-9; j>=0 && mod8[j]>mod8[attackSq]; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; j<64 && mod8[j]>mod8[attackSq]; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
					}
				}
				else {
					if (mod8[i]<mod8[plateau.roiB]) {
						int j;
						for (j=i+9; j<64 && mod8[j]<mod8[attackSq]; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; j>=0 && mod8[j]<mod8[attackSq]; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
					}
					else if (mod8[i]>mod8[plateau.roiB]) {
						int j;
						for (j=i-9; j>=0 && mod8[j]>mod8[attackSq]; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; j<64 && mod8[j]>mod8[attackSq]; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
					}
				}
			}
			if (!cases.empty()) {
				ok=true;
				plateau.board[i]=0;
				// check si decouvertes
				if (mod8[plateau.roiB]==mod8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-8; j>=0; j-=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (div8[plateau.roiB]==div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+1; j<plateau.roiB+8-mod8[plateau.roiB]; j++) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-1; j>=plateau.roiB-mod8[plateau.roiB]; j--) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[plateau.roiB]-mod8[i]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+9; j<64 && mod8[j]>0; j+=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+7; j<64 && mod8[j]<7; j+=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				if (ok) {
					for (int j=(int)cases.size()-1; j>=0; j--) {
						coup.arr=cases[j];
						setCoupsW.push_back(coup);
					}
				}
				plateau.board[i]=3;
			}
		}

		else if (plateau[i]==4) {
			coup.dep=i;
			cases.clear();
			if (div8[attackSq]==div8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (div8[i]==div8[attackSq] && mod8[i]>mod8[attackSq]) {
						int j;
						for (j=attackSq+1; plateau[j]==0; j++) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (mod8[i]>mod8[plateau.roiB] && mod8[i]<=mod8[attackSq]) {
						if (div8[i]<div8[plateau.roiB]) {
							int j;
							for (j=i+8; j<plateau.roiB; j+=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
						else if (div8[i]>div8[plateau.roiB]) {
							int j;
							for (j=i-8; j>attackSq; j-=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
				else {
					if (div8[i]==div8[attackSq] && mod8[i]<mod8[attackSq]) {
						int j;
						for (j=attackSq-1; plateau[j]==0; j--) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (mod8[i]>=mod8[attackSq] && mod8[i]<mod8[plateau.roiB]) {
						if (div8[i]<div8[plateau.roiB]) {
							int j;
							for (j=i+8; j<attackSq; j+=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
						else if (div8[i]>div8[plateau.roiB]) {
							int j;
							for (j=i-8; j>plateau.roiB; j-=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
			}
			else if (mod8[attackSq]==mod8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (mod8[i]==mod8[attackSq] && div8[i]>div8[attackSq]) {
						int j;
						for (j=attackSq+8; plateau[j]==0; j+=8) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (div8[i]>div8[plateau.roiB] && div8[i]<=div8[attackSq]) {
						if (mod8[i]<mod8[plateau.roiB]) {
							int j;
							for (j=i+1; mod8[j]<mod8[plateau.roiB]; j++) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
						else if (mod8[i]>mod8[plateau.roiB]) {
							int j;
							for (j=i-1; mod8[j]>mod8[plateau.roiB]; j--) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
				else {
					if (mod8[i]==mod8[attackSq] && div8[i]<div8[attackSq]) {
						int j;
						for (j=attackSq-8; plateau[j]==0; j-=8) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (div8[i]>=div8[attackSq] && div8[i]<div8[plateau.roiB]) {
						if (mod8[i]<mod8[plateau.roiB]) {
							int j;
							for (j=i+1; mod8[j]<mod8[plateau.roiB]; j++)
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
						else if (mod8[i]>mod8[plateau.roiB]) {
							int j;
							for (j=i-1; mod8[j]>mod8[plateau.roiB]; j--)
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
			}
			if (!cases.empty()) {
				ok=true;
				plateau.board[i]=0;
				// check si decouvertes
				if (mod8[plateau.roiB]-mod8[i]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+9; j<64 && mod8[j]>0; j+=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+7; j<64 && mod8[j]<7; j+=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				if (ok) {
					if (i==0) coup.grb=false;
					else if (i==7) coup.prb=false;
					for (int j=(int)cases.size()-1; j>=0; j--) {
						coup.arr=cases[j];
						setCoupsW.push_back(coup);
					}
				}
				plateau.board[i]=4;
			}	
		}

		else if (plateau[i]==5) {
			coup.dep=i;
			cases.clear();
			if (div8[attackSq]==div8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (div8[i]==div8[attackSq] && mod8[i]>mod8[attackSq]) {
						int j;
						for (j=attackSq+1; plateau[j]==0; j++) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (div8[i]<div8[plateau.roiB]) {
						int j;
						for (j=i+9; mod8[j]>0 && j<plateau.roiB; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; mod8[j]<7 && j<plateau.roiB; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						if (mod8[i]>mod8[plateau.roiB] && mod8[i]<=mod8[attackSq]) {
							for (j=i+8; j<plateau.roiB; j+=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
					else if (div8[i]>div8[plateau.roiB]) {
						int j;
						for (j=i-9; mod8[j]<7 && j>attackSq; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; mod8[j]>0 && j>attackSq; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						if (mod8[i]>mod8[plateau.roiB] && mod8[i]<=mod8[attackSq]) {
							for (j=i-8; j>attackSq; j-=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
				else {
					if (div8[i]==div8[attackSq] && mod8[i]<mod8[attackSq]) {
						int j;
						for (j=attackSq-1; plateau[j]==0; j--) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (div8[i]<div8[attackSq]) {
						int j;
						for (j=i+9; mod8[j]>0 && j<attackSq; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; mod8[j]<7 && j<attackSq; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						if (mod8[i]>=mod8[attackSq] && mod8[i]<mod8[plateau.roiB]) {
							for (j=i+8; j<attackSq; j+=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
					else if (div8[i]>div8[attackSq]) {
						int j;
						for (j=i-9; mod8[j]<7 && j>plateau.roiB; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; mod8[j]>0 && j>plateau.roiB; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && div8[j]==div8[plateau.roiB]) cases.push_back(j);
						if (mod8[i]>=mod8[attackSq] && mod8[i]<mod8[plateau.roiB]) {
							for (j=i-8; j>plateau.roiB; j-=8) 
								if (plateau[j]!=0) break;
							if (div8[j]==div8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
			}
			else if (mod8[attackSq]==mod8[plateau.roiB]) {
				if (plateau.roiB<attackSq) {
					if (mod8[i]==mod8[attackSq] && div8[i]>div8[attackSq]) {
						int j;
						for (j=attackSq+8; plateau[j]==0; j+=8) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (mod8[i]<mod8[plateau.roiB]) {
						int j;
						for (j=i+9; j<64 && mod8[j]<mod8[attackSq]; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; j>=0 && mod8[j]<mod8[attackSq]; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						if (div8[i]>div8[plateau.roiB] && div8[i]<=div8[attackSq]) {
							for (j=i+1; mod8[j]<mod8[plateau.roiB]; j++) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
					else if (mod8[i]>mod8[plateau.roiB]) {
						int j;
						for (j=i-9; j>=0 && mod8[j]>mod8[attackSq]; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; j<64 && mod8[j]>mod8[attackSq]; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && plateau.roiB<j && j<=attackSq && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						if (div8[i]>div8[plateau.roiB] && div8[i]<=div8[attackSq]) {
							for (j=i-1; mod8[j]>mod8[plateau.roiB]; j--) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
				else {
					if (mod8[i]==mod8[attackSq] && div8[i]<div8[attackSq]) {
						int j;
						for (j=attackSq-8; plateau[j]==0; j-=8) {}
						if (j==i) {
							coup.arr=attackSq;
							setCoupsW.push_back(coup);
						}
					}
					else if (mod8[i]<mod8[plateau.roiB]) {
						int j;
						for (j=i+9; j<64 && mod8[j]<mod8[attackSq]; j+=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i-7; j>=0 && mod8[j]<mod8[attackSq]; j-=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=0 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						if (div8[i]>=div8[attackSq] && div8[i]<div8[plateau.roiB]) {
							for (j=i+1; mod8[j]<mod8[plateau.roiB]; j++) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
					else if (mod8[i]>mod8[plateau.roiB]) {
						int j;
						for (j=i-9; j>=0 && mod8[j]>mod8[attackSq]; j-=9) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						for (j=i+7; j<64 && mod8[j]>mod8[attackSq]; j+=7) 
							if (plateau[j]!=0) break;
						if (mod8[j]!=7 && attackSq<=j && j<plateau.roiB && mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						if (div8[i]>=div8[attackSq] && div8[i]<div8[plateau.roiB]) {
							for (j=i-1; mod8[j]>mod8[plateau.roiB]; j--) 
								if (plateau[j]!=0) break;
							if (mod8[j]==mod8[plateau.roiB]) cases.push_back(j);
						}
					}
				}
			}
			if (!cases.empty()) {
				ok=true;
				plateau.board[i]=0;
				// check si decouvertes
				if (mod8[plateau.roiB]==mod8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+8; j<64; j+=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-8; j>=0; j-=8) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (div8[plateau.roiB]==div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+1; j<plateau.roiB+8-mod8[plateau.roiB]; j++) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-1; j>=plateau.roiB-mod8[plateau.roiB]; j--) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-4 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[plateau.roiB]-mod8[i]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+9; j<64 && mod8[j]>0; j+=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-9; j>=0 && mod8[j]<7; j-=9) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				else if (mod8[i]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[i]) {
					if (plateau.roiB<i) {
						for (int j=plateau.roiB+7; j<64 && mod8[j]<7; j+=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
					else {
						for (int j=plateau.roiB-7; j>=0 && mod8[j]>0; j-=7) {
							if (plateau[j]>0) break;
							if (plateau[j]<0) {
								if (plateau[j]==-3 || plateau[j]==-5) ok=false;
								break;
							}
						}
					}
				}
				if (ok) {
					for (int j=(int)cases.size()-1; j>=0; j--) {
						coup.arr=cases[j];
						setCoupsW.push_back(coup);
					}
				}
				plateau.board[i]=5;
			}
		}

		else {
			int diffCol=mod8[attackSq]-mod8[plateau.roiB];
			int diffRag=div8[attackSq]-div8[plateau.roiB];
			coup.dep=i;
			coup.prb=false;
			coup.grb=false;
			if (mod8[i]>0) {
				if (plateau[i-1]<=0 && (diffCol==-1 || diffCol==0)) {
					coup.arr=i-1;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
				if (i>8 && plateau[i-9]<=0) {
					coup.arr=i-9;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
				if (i<=56 && plateau[i+7]<=0) {
					coup.arr=i+7;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
			}
			if (mod8[i]<7) {
				coup.arr=i+1;
				if (plateau[i+1]<=0 && (diffCol==1 || diffCol==0)) {
					coup.arr=i+1;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
				if (i>=8 && plateau[i-7]<=0) {
					coup.arr=i-7;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
				if (i<56 && plateau[i+9]<=0) {
					coup.arr=i+9;
					if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
				}
			}
			if (i>=8 && plateau[i-8]<=0 && (diffRag==-1 || diffRag==0)) {
				coup.arr=i-8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
			if (i<56 && plateau[i+8]<=0 && (diffRag==1 || diffRag==0)) {
				coup.arr=i+8;
				if (!underCheckW_K(coup)) setCoupsW.push_back(coup);
			}
		}
	}

	return;
}
