/* programme principal: arguments=fichier temps dernierCoup+flags; renvoie un coup+flags */
    
#include "Global.h"
#include "Definitions.h"
#include "Coup.h"
#include "Plateau.h"
#include "AlphaBeta.h"
#include <iostream>

using namespace std;

int main(int argc, char **argv) {

	Global g=Global();
	setCoupsW.init();
	coupsRoiW.init();
	setCoupsB.init();
	coupsRoiB.init();
	coupsAux.init();
	plateau=Plateau(argv[1]);

	// le dernier coup joue est donne en dernier argument, bool 1 si true 0 si false
	lastMove=LightMove((argv[3][1]-'0')*8+(argv[3][0]-'a')%8,(argv[3][3]-'0')*8+(argv[3][2]-'a')%8,
		(argv[3][4]-'0')!=0,(argv[3][5]-'0')!=0,(argv[3][6]-'0')!=0,(argv[3][7]-'0')!=0);

	/* info pour construire la biblio, en attendant de le faire automatiquement..
	* cout << plateau << endl << plateau.codeBiblio().clef << endl;
	*/
	
	if (argv[2][0]=='-') { // l'ordinateur a les noirs 
		AlphaBeta AB=AlphaBeta(-atof(argv[2]));
		cout << AB.coupAB_B() << endl; 
	}
	else { // l'ordinateur a les blancs 
		AlphaBeta AB=AlphaBeta(atof(argv[2]));
		cout << AB.coupAB_W() << endl;	
	}

	return 0;		
}

