#include "Global.h"
#include "Definitions.h"
#include "StatutRoi.h"

// teste si le roi est en echec simple, double..etc
void checkKingW() { 

	check=false;
	sCheck=-1;
	dec=false;
	int i;
    	
	// on regarde si le coup precedent adverse est un echec, simple ou double: (utile pr underCheck)
	
	// puis les promotions en tour: elles peuvent etre un echec double si prise
	// on les detecte en regardant si les rangees + colonnes de depart et arrivee different
	if (lastMove.arr<8 && plateau[lastMove.arr]==-4) {
		if (lastMove.dep-lastMove.arr==7 && plateau[lastMove.arr-1]==6) {
			check=true;
			for (int i=plateau.roiB+8; i<64; i+=8) {
				if (plateau[i]>0) break;
				if (plateau[i]<0) {
					if (plateau[i]==-4 || plateau[i]==-5) dec=true;
					break;
				}
			}
			return;
		}
		else if (lastMove.dep-lastMove.arr==9 && plateau[lastMove.arr+1]==6) {
			check=true;
			for (int i=plateau.roiB+8; i<64; i+=8) {
				if (plateau[i]>0) break;
				if (plateau[i]<0) {
					if (plateau[i]==-4 || plateau[i]==-5) dec=true;
					break;
				}
			}
			return;
		}
	}
	
	switch (plateau[lastMove.arr]) {
	case -1:
		// le pion donne echec
		if (lastMove.arr-plateau.roiB==7 && mod8[lastMove.arr]<7) {
			check=true;
			if (lastMove.dep-lastMove.arr==9) {
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;	
					}
				}
			}
			break;
		}
		if (lastMove.arr-plateau.roiB==9 && mod8[lastMove.arr]>0) {
			check=true;
			if (lastMove.dep-lastMove.arr==7) {
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;	
					}
				}
			}
			break;
		}
		// il ne donne pas echec
		if (mod8[lastMove.dep]!=mod8[lastMove.arr] && mod8[plateau.roiB]==mod8[lastMove.dep]) {
			if (plateau.roiB<lastMove.dep) {
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
			}
			else {
				for (i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
			}
			break;
		}
		if (div8[plateau.roiB]==div8[lastMove.dep]) {
			if (lastMove.dep>plateau.roiB) {
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
			}
			else {
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
			}
			break;
		}
		// meme diago
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
			if (lastMove.dep<plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			break;
		}
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;	
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			break;
		}
		// pion capture en passant sur meme diago que le roi
		if (lastMove.ep) {
			int caseTest=lastMove.arr+8;
			if (mod8[caseTest]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[caseTest]) {
				if (caseTest<plateau.roiB) {
					// roi a gauche
					for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
							break;	
						}
					}
					if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
					}
				}
				else {
					// roi a droite
					for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
							break;	
						}
					}
					if (i<64 && plateau[i]<0 && mod8[i]!=7) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
					}
				}
				break;
			}
			if (mod8[caseTest]-mod8[plateau.roiB]==div8[caseTest]-div8[plateau.roiB]) {
				if (caseTest>plateau.roiB) {
					// roi a gauche
					for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
							break;	
						}
					}
					if (i<64 && plateau[i]<0 && mod8[i]!=0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
					}
				}
				else {
					// roi a droite
					for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
							break;	
						}
					}
					if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
					}
				}
			}
		}
		break;
	case -2:
		// le cavalier donne echec
		// sud est
		if ((plateau.roiB-lastMove.arr==15 && mod8[lastMove.arr]>0) || (plateau.roiB-lastMove.arr==6 && mod8[lastMove.arr]>1)) {
			check=true;
			if (mod8[plateau.roiB]==mod8[lastMove.dep]) {
				for (i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiB]==div8[lastMove.dep]) {
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (plateau.roiB-lastMove.dep==21 && mod8[lastMove.dep]<7) {
				for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) dec=true;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) dec=true;
				}
			}
			break;
		}
		// nord est
		if ((lastMove.arr-plateau.roiB==17 && mod8[lastMove.arr]>0) || (lastMove.arr-plateau.roiB==10 && mod8[lastMove.arr]>1)) {
			check=true;
			if (mod8[plateau.roiB]==mod8[lastMove.dep]) {
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiB]==div8[lastMove.dep]) {
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (lastMove.dep-plateau.roiB==27 && mod8[lastMove.dep]<7) {
				for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) dec=true;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) dec=true;
				}
			}
			break;
		}
		// nord ouest
		if ((lastMove.arr-plateau.roiB==15 && mod8[lastMove.arr]<7) || (lastMove.arr-plateau.roiB==6 && mod8[lastMove.arr]<6)) {
			check=true;
			if (mod8[plateau.roiB]==mod8[lastMove.dep]) {
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiB]==div8[lastMove.dep]) {
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (lastMove.dep-plateau.roiB==21 && mod8[lastMove.dep]>0) {
				for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) dec=true;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) dec=true;
				}
			}
			break;
		}
		// sud ouest
		if ((plateau.roiB-lastMove.arr==17 && mod8[lastMove.arr]<7) || (plateau.roiB-lastMove.arr==10 && mod8[lastMove.arr]<6)) {
			check=true;
			if (mod8[plateau.roiB]==mod8[lastMove.dep]) {
				for (i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiB]==div8[lastMove.dep]) {
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) dec=true;
						break;
					}
				}
			}
			else if (plateau.roiB-lastMove.dep==27 && mod8[lastMove.dep]>0) {
				for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) dec=true;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) dec=true;
				}
			}
			break;
		}
		// il ne donne pas echec
		// roi sur meme colonne
		if (mod8[lastMove.dep]==mod8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi en dessous
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi au dessus
				for (i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme rangee
		if (div8[lastMove.dep]==div8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme diagonale
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
			if (lastMove.dep<plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			break;
		}
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
		}
		break;
	case -3:
		// le fou donne echec
		if (mod8[lastMove.arr]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.arr]) {
			if (lastMove.arr<plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB-7; j>lastMove.arr; j-=7) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiB]) {
						for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiB-8; i>=0; i-=8) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB+7; j<lastMove.arr; j+=7) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiB]) {
						for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiB+8; i<64; i+=8) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiB]==div8[lastMove.arr]-div8[plateau.roiB]) {
			if (lastMove.arr>plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB+9; j<lastMove.arr; j+=9) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiB]) {
						for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiB+8; i<64; i+=8) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB-9; j>lastMove.arr; j-=9) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiB]) {
						for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiB-8; i>=0; i-=8) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		// il ne donne pas echec
		// roi sur meme colonne
		if (mod8[lastMove.dep]==mod8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi en dessous
				for (i=plateau.roiB+8; i<64; i+=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi au dessus
				for (i=plateau.roiB-8; i>=0; i-=8) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme rangee
		if (div8[lastMove.dep]==div8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
			}
		}
		break;
	case -4:
		// la tour donne echec
		if (mod8[lastMove.arr]==mod8[plateau.roiB]) {
			if (lastMove.arr>plateau.roiB) {
				// roi en dessous
				int j;
				for (j=plateau.roiB+8; j<lastMove.arr; j+=8) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						break;
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
						if (lastMove.dep>plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
					}
					break;
				}
			}
			else {
				// roi au dessus
				int j;
				for (j=plateau.roiB-8; j>lastMove.arr; j-=8) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						break;
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
						if (lastMove.dep>plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
					}
					break;
				}
			}
		}
		else if (div8[lastMove.arr]==div8[plateau.roiB]) {
			if (lastMove.arr>plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB+1; j<lastMove.arr; j++) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						break;
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
						if (lastMove.dep>plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB-1; j>lastMove.arr; j--) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						break;
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
						if (lastMove.dep>plateau.roiB) {
							// roi a gauche
							for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]<0 && mod8[i]!=0) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-3 || plateau[i]==-5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
								if (plateau[i]==-3 || plateau[i]==-5) dec=true;
							}
						}
					}
					break;
				}
			}
		}
		// elle ne donne pas echec
		// roi sur meme diagonale
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.dep]) {
			if (lastMove.dep<plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			break;
		}
		if (mod8[lastMove.dep]-mod8[plateau.roiB]==div8[lastMove.dep]-div8[plateau.roiB]) {
			if (lastMove.dep>plateau.roiB) {
				// roi a gauche
				for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=0) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
					if (plateau[i]==-3 || plateau[i]==-5) sCheck=i;
				}
			}
		}
		break;
	case -5:
		// dame: pas de decouverte possible ! ..sauf si c'est une promotion (cas frequent, en plus)
		// pour eviter d'avoir a ajouter un flag, on check si lastMove.arrivee sur 8eme et lastMove.depart de 7eme..
		// la dame donne echec
		if (mod8[lastMove.arr]==mod8[plateau.roiB]) {
			if (lastMove.arr>plateau.roiB) {
				// roi en dessous
				int j;
				for (j=plateau.roiB+8; j<lastMove.arr; j+=8) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) check=true;
				break;
			}
			else {
				// roi au dessus
				int j;
				for (j=plateau.roiB-8; j>lastMove.arr; j-=8) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[plateau.roiB]==1 && div8[lastMove.dep]==1) {
						if (mod8[lastMove.dep]>mod8[plateau.roiB]) {
							// roi a gauche
							for (i=plateau.roiB+1; i<16; i++) {
								if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-4 || plateau[i]==-5) dec=true;
									break;
								}
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiB-1; i>=8; i--) {
							if (plateau[i]>0) break;
								if (plateau[i]<0) {
									if (plateau[i]==-4 || plateau[i]==-5) dec=true;
									break;
								}
							}
						}
					}
					break;
				}
			}
		}
		else if (div8[lastMove.arr]==div8[plateau.roiB]) {
			if (lastMove.arr>plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB+1; j<lastMove.arr; j++) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) check=true;
				break;
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB-1; j>lastMove.arr; j--) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) check=true;
				break;
			}	
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiB]==div8[plateau.roiB]-div8[lastMove.arr]) {
			if (lastMove.arr<plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB-7; j>lastMove.arr; j-=7) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==1 && div8[lastMove.arr]==0) {
						for (i=plateau.roiB+1; i<16; i++) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB+7; j<lastMove.arr; j+=7) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) check=true;
				break;
			}
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiB]==div8[lastMove.arr]-div8[plateau.roiB]) { 
			if (lastMove.arr>plateau.roiB) {
				// roi a gauche
				int j;
				for (j=plateau.roiB+9; j<lastMove.arr; j+=9) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) check=true;
				break;
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiB-9; j>lastMove.arr; j-=9) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==1 && div8[lastMove.arr]==0) {
						for (i=plateau.roiB-1; i>=8; i--) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		// la dame ne donne pas echec
		if (div8[lastMove.dep]==1 && div8[lastMove.arr]==0) {
			if (mod8[lastMove.dep]==mod8[lastMove.arr]) {
				if (div8[plateau.roiB]==1) {
					if (plateau.roiB<lastMove.dep) {
						// roi a gauche
						for (i=plateau.roiB+1; i<16; i++) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
								break;
							}
						}
					}
					else {
						// roi a droite
						for (i=plateau.roiB-1; i>=8; i--) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								if (plateau[i]==-4 || plateau[i]==-5) sCheck=i;
								break;
							}
						}
					}
				}
			}
		}
		break;
	default: break;
	}
	
	return;
}

void checkKingB() { 

	check=false;
	sCheck=-1;
	dec=false;
	int i;
	
	// on regarde si le coup precedent adverse est un echec, simple ou double: (utile pr underCheck)
	
	// d'abord les promotions en tour: elles peuvent etre un echec double si prise
	// on les detecte en regardant si les rangees + colonnes de depart et arrivee different
	if (lastMove.arr>=56 && plateau[lastMove.arr]==4) {
		if (lastMove.arr-lastMove.dep==7 && plateau[lastMove.arr+1]==-6) {
			check=true;
			for (int i=plateau.roiN-8; i>=0; i-=8) {
				if (plateau[i]<0) break;
				if (plateau[i]>0) {
					if (plateau[i]==4 || plateau[i]==5) dec=true;
					break;
				}
			}
			return;
		}
		else if (lastMove.arr-lastMove.dep==9 && plateau[lastMove.arr-1]==-6) {
			check=true;
			for (int i=plateau.roiN-8; i>=0; i-=8) {
				if (plateau[i]<0) break;
				if (plateau[i]>0) {
					if (plateau[i]==4 || plateau[i]==5) dec=true;
					break;
				}
			}
			return;
		}
	}
	
	switch (plateau[lastMove.arr]) {
	case 1:
		// le pion donne echec
		if (plateau.roiN-lastMove.arr==7 && mod8[lastMove.arr]>0) {
			check=true;
			if (lastMove.arr-lastMove.dep==9) {
				for (i=plateau.roiN-8; i>=0; i-=8) {  
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			break;
		}
		if (plateau.roiN-lastMove.arr==9 && mod8[lastMove.arr]<7) {
			check=true;
			if (lastMove.arr-lastMove.dep==7) {
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			break;
		}
		// il ne donne pas echec
		if (mod8[lastMove.dep]!=mod8[lastMove.arr] && mod8[plateau.roiN]==mod8[lastMove.dep]) {
			if (plateau.roiN<lastMove.dep) {
				for (i=plateau.roiN+8; i<64; i+=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		if (div8[plateau.roiN]==div8[lastMove.dep]) {
			if (lastMove.dep>plateau.roiN) {
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// meme diago
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
			if (lastMove.dep<plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			break;
		}
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			break;
		}
		// pion capture en passant sur meme diago que le roi
		if (lastMove.ep) {
			int caseTest=lastMove.arr-8;
			if (mod8[caseTest]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[caseTest]) {
				if (caseTest<plateau.roiN) {
					// roi a gauche
					for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							if (plateau[i]==3 || plateau[i]==5) sCheck=i;
							break;	
						}
					}
					if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
					}
				}
				else {
					// roi a droite
					for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							if (plateau[i]==3 || plateau[i]==5) sCheck=i;
							break;	
						}
					}
					if (i<64 && plateau[i]>0 && mod8[i]!=7) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
					}
				}
				break;
			}
			if (mod8[caseTest]-mod8[plateau.roiN]==div8[caseTest]-div8[plateau.roiN]) {
				if (caseTest>plateau.roiN) {
					// roi a gauche
					for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							if (plateau[i]==3 || plateau[i]==5) sCheck=i;
							break;	
						}
					}
					if (i<64 && plateau[i]>0 && mod8[i]!=0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
					}
				}
				else {
					// roi a droite
					for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							if (plateau[i]==3 || plateau[i]==5) sCheck=i;
							break;	
						}
					}
					if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
					}
				}
			}
		}
		break;
	case 2:
		// le cavalier donne echec
		// sud est
		if ((plateau.roiN-lastMove.arr==15 && mod8[lastMove.arr]>0) || (plateau.roiN-lastMove.arr==6 && mod8[lastMove.arr]>1)) {
			check=true;
			if (mod8[plateau.roiN]==mod8[lastMove.dep]) {
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiN]==div8[lastMove.dep]) {
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (plateau.roiN-lastMove.dep==21 && mod8[lastMove.dep]<7) {
				for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) dec=true;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) dec=true;
				}
			}
			break;
		}
		// nord est
		if ((lastMove.arr-plateau.roiN==17 && mod8[lastMove.arr]>0) || (lastMove.arr-plateau.roiN==10 && mod8[lastMove.arr]>1)) {
			check=true;
			if (mod8[plateau.roiN]==mod8[lastMove.dep]) {
				for (i=plateau.roiN+8; i<64; i+=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiN]==div8[lastMove.dep]) {
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (lastMove.dep-plateau.roiN==27 && mod8[lastMove.dep]<7) {
				for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) dec=true;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) dec=true;
				}
			}
			break;
		}
		// nord ouest
		if ((lastMove.arr-plateau.roiN==15 && mod8[lastMove.arr]<7) || (lastMove.arr-plateau.roiN==6 && mod8[lastMove.arr]<6)) {
			check=true;
			if (mod8[plateau.roiN]==mod8[lastMove.dep]) {
				for (i=plateau.roiN+8; i<64; i+=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiN]==div8[lastMove.dep]) {
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (lastMove.dep-plateau.roiN==21 && mod8[lastMove.dep]>0) {
				for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) dec=true;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) dec=true;
				}
			}
			break;
		}
		// sud ouest
		if ((plateau.roiN-lastMove.arr==17 && mod8[lastMove.arr]<7) || (plateau.roiN-lastMove.arr==10 && mod8[lastMove.arr]<6)) {
			check=true;
			if (mod8[plateau.roiN]==mod8[lastMove.dep]) {
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (div8[plateau.roiN]==div8[lastMove.dep]) {
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) dec=true;
						break;
					}
				}
			}
			else if (plateau.roiN-lastMove.dep==27 && mod8[lastMove.dep]>0) {
				for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) dec=true;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) dec=true;
				}
			}
			break;
		} 
		// il ne donne pas echec
		// roi sur meme colonne
		if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) {
				// roi en dessous
				for (i=plateau.roiN+8; i<64; i+=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi au dessus
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme rangee
		if (div8[lastMove.dep]==div8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme diagonale
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
			if (lastMove.dep<plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			break;
		}  
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) { 
				// roi a gauche
				for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else { 
				// roi a droite
				for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
		}
		break;
	case 3:
		// le fou donne echec
		if (mod8[lastMove.arr]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.arr]) {
			if (lastMove.arr<plateau.roiN) {
				// roi a gauche
				int j;
				for (j=plateau.roiN-7; j>lastMove.arr; j-=7) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiN]) {
						for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiN-8; i>=0; i-=8) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiN+7; j<lastMove.arr; j+=7) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiN]) {
						for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiN+8; i<64; i+=8) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiN]==div8[lastMove.arr]-div8[plateau.roiN]) {
			if (lastMove.arr>plateau.roiN) {
				// roi a gauche
				int j;
				for (j=plateau.roiN+9; j<lastMove.arr; j+=9) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiN]) {
						for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiN+8; i<64; i+=8) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiN-9; j>lastMove.arr; j-=9) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==div8[plateau.roiN]) {
						for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
						for (i=plateau.roiN-8; i>=0; i-=8) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		// il ne donne pas echec
		// roi sur meme colonne
		if (mod8[lastMove.dep]==mod8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) {
				// roi en dessous
				for (i=plateau.roiN+8; i<64; i+=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi au dessus
				for (i=plateau.roiN-8; i>=0; i-=8) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			break;
		}
		// roi sur meme rangee
		if (div8[lastMove.dep]==div8[plateau.roiN]) {
			if (lastMove.dep>plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==4 || plateau[i]==5) sCheck=i;
						break;
					}
				}
			}
		}
		break;
	case 4: 
		// la tour donne echec
		if (mod8[lastMove.arr]==mod8[plateau.roiN]) { 
			if (lastMove.arr>plateau.roiN) {
				// roi en dessous
				int j;
				for (j=plateau.roiN+8; j<lastMove.arr; j+=8) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					else if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
						if (lastMove.dep>plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					break;
				}
			}
			else {
				// roi au dessus
				int j;
				for (j=plateau.roiN-8; j>lastMove.arr; j-=8) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
						if (lastMove.dep>plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					break;
				}
			}
		} 
		if (div8[lastMove.arr]==div8[plateau.roiN]) { 
			if (lastMove.arr>plateau.roiN) {
				// roi a gauche
				int j;
				for (j=plateau.roiN+1; j<lastMove.arr; j++) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					else if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
						if (lastMove.dep>plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiN-1; j>lastMove.arr; j--) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) {
					check=true;
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) {
						if (lastMove.dep<plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) {
						if (lastMove.dep>plateau.roiN) {
							// roi a gauche
							for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i<64 && plateau[i]>0 && mod8[i]!=0) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==3 || plateau[i]==5) dec=true;
									break;
								}
							}
							if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
								if (plateau[i]==3 || plateau[i]==5) dec=true;
							}
						}
					}
					break;
				}
			}
		} 
		// elle ne donne pas echec
		// roi sur meme diagonale
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.dep]) { 
			if (lastMove.dep<plateau.roiN) { 
				// roi a gauche
				for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			break;
		} 
		if (mod8[lastMove.dep]-mod8[plateau.roiN]==div8[lastMove.dep]-div8[plateau.roiN]) { 
			if (lastMove.dep>plateau.roiN) {
				// roi a gauche
				for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=0) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
			else {
				// roi a droite
				for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						if (plateau[i]==3 || plateau[i]==5) sCheck=i;
						break;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
					if (plateau[i]==3 || plateau[i]==5) sCheck=i;
				}
			}
		} 
		break;
	case 5:
		// dame: pas de decouverte possible ! ..sauf si c'est une promotion (cas frequent, en plus)
		// pour eviter d'avoir a ajouter un flag, on check si lastMove.arrivee sur 8eme et lastMove.depart de 7eme..
		// la dame donne echec
		if (mod8[lastMove.arr]==mod8[plateau.roiN]) {
			if (lastMove.arr<plateau.roiN) {
				// roi au dessus
				int j;
				for (j=plateau.roiN-8; j>lastMove.arr; j-=8) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) check=true;
				break;
			}
			else {
				// roi en dessous
				int j;
				for (j=plateau.roiN+8; j<lastMove.arr; j+=8) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[plateau.roiN]==6 && div8[lastMove.dep]==6) {
						if (mod8[lastMove.dep]>mod8[plateau.roiN]) {
							// roi a gauche
							for (i=plateau.roiN+1; i<56; i++) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==4 || plateau[i]==5) dec=true;
									break;
								}
							}
						}
						else {
							// roi a droite
							for (i=plateau.roiN-1; i>=48; i--) {
								if (plateau[i]<0) break;
								if (plateau[i]>0) {
									if (plateau[i]==4 || plateau[i]==5) dec=true;
									break;
								}
							}
						}
					}
					break;
				}
			}
		}
		else if (div8[lastMove.arr]==div8[plateau.roiN]) {
			if (lastMove.arr>plateau.roiN) {
				// roi a gauche
				int j;
				for (j=plateau.roiN+1; j<lastMove.arr; j++) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) check=true;
				break;
			}
			else {
				// roi a droite
				int j;
				for (j=plateau.roiN-1; j>lastMove.arr; j--) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) check=true;
				break;
			}	
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiN]==div8[plateau.roiN]-div8[lastMove.arr]) {
			if (lastMove.arr>plateau.roiN) {
				// roi a droite
				int j;
				for (j=plateau.roiN+7; j<lastMove.arr; j+=7) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==6 && div8[lastMove.arr]==7) {
						for (i=plateau.roiN-1; i>=48; i--) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
			else {
				// roi a gauche
				int j;
				for (j=plateau.roiN-7; j>lastMove.arr; j-=7) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) check=true;
				break;
			}
		}
		else if (mod8[lastMove.arr]-mod8[plateau.roiN]==div8[lastMove.arr]-div8[plateau.roiN]) {
			if (lastMove.arr<plateau.roiN) {
				// roi a droite
				int j;
				for (j=plateau.roiN-9; j>lastMove.arr; j-=9) if (plateau[j]!=0) break;
				if (j<=lastMove.arr) check=true;
				break;
			}
			else {
				// roi a gauche
				int j;
				for (j=plateau.roiN+9; j<lastMove.arr; j+=9) if (plateau[j]!=0) break;
				if (j>=lastMove.arr) {
					check=true;
					if (div8[lastMove.dep]==6 && div8[lastMove.arr]==7) {
						for (i=plateau.roiN+1; i<56; i++) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) dec=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		// la dame ne donne pas echec
		if (div8[lastMove.dep]==6 && div8[lastMove.arr]==7) {
			if (mod8[lastMove.dep]==mod8[lastMove.arr]) {
				if (div8[plateau.roiN]==6) {
					if (plateau.roiN<lastMove.dep) {
						// roi a gauche
						for (i=plateau.roiN+1; i<56; i++) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) sCheck=i;
								break;
							}
						}
					}
					else {
						// roi a droite
						for (i=plateau.roiN-1; i>=48; i--) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								if (plateau[i]==4 || plateau[i]==5) sCheck=i;
								break;
							}
						}
					}
				}
			}
		}
		break;
	default: break;
	}

	return;
}
